(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 1) {
			return callback('账号不能为空');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		plus.nativeUI.showWaiting("登录中...", {
			width: "120px"
		});
		$getAjax(SERVICE.login,{
			data:{
				name:loginInfo.account,
				pwd:loginInfo.password,
//				fromclient:"teacherApp"
			},
			success:function(data){
				if(data.result == 0){
					return owner.createState(data.data, callback);
				}else{
					return callback(data.msg);
				}
			}
		})
	};

	owner.createState = function(data, callback) {
		var state = owner.getState();
		state.data = data;
		owner.setState(state);
//		document.cookie="clientauthtoken="+data;
		plus.navigator.setCookie(ROOT_URL,"clientauthtoken="+data)
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	};


	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
}(mui, window.app = {}));