$(function(){
    back = $(".back");
    clear = $(".clear");
    // 撤销
    $(document).on("tap",".back",function() {
        xyList.pop();
        xyListTwo.pop();
        arr.pop();
        obj.clearRect(0, 0, width, height);
        if(arr.length>0){
            obj.putImageData(arr[arr.length - 1], 0, 0, 0, 0, width, height);
        }
    });
    // 清除
    $(document).on("tap",".clear",function() {
        arr = [];
        xyList = [];
        xyListTwo = [];
        penAllList = [];
        penHistoryList = [];
        penZoomList = [];
        textAreaList = [];
        obj.clearRect(0, 0, width, height);
        if(arr.length>0){
            obj.putImageData(arr[arr.length - 1], 0, 0, 0, 0, width, height);
        }
    });
});





//element 画布
//imgUrl 图片地址
//z 是背景图宽度
//r 是背景图高度
function initCanvas(element, imgUrl,isOnload) {
    el = element;
    canvas = document.getElementById(element);
    img.src = imgUrl;
    width = img.width * tz;
    height = img.height * tz;
    canvas.width = width;
    canvas.height = height;
    obj = canvas.getContext('2d');
    $('#' + element).attr("style", "background:url('" + imgUrl + "') no-repeat;background-size: 100% 100%;");
    if (type == undefined) {
        type = "pen"; //画图类型
    }
    if (color == undefined) {
        color = "#f00"; //画图颜色
    }
    if (linewidth == undefined) {
        linewidth = "3"; //线的粗细
    }
    if (style == undefined) {
        style = "stroke";
    }
    typechoose = $(".type li");
    colorchoose = document.querySelector("input[type=color]");
    widthchoose = document.querySelector(".linewidth input[type=number]");
    if(isOnload){
        // 绘制形状
        typechoose.each(function(index, ele) {
        	$(ele).on("tap",function(){
        		$("textarea").blur();
        		typechoose.removeClass("typeactive");
                $(this).toggleClass("typeactive");
                type = $(this).attr("data");
                if ($(this).is(".line")) {
                    style = "stroke";
                    $(".stroke").addClass("styleactive");
                }
                if(type == "plusMark"){
                	vm.markerType = 0;
                	vm.differentMarkers();
                }else if(type == "reduceMark"){
                	vm.markerType = 1;
                	vm.differentMarkers();
                }else{
                	vm.markerType = -1;
                }
//              $('#markerType').val(-1);
//              changeMarkerType(-1,1);
        	})
        });

        // 颜色选择
        colorchoose.onchange = function() {
            color = this.value;
        };
        // 粗细改变
        widthchoose.onchange = function() {
            linewidth = this.value;
        };
        //鼠标按下事件
        canvas.ontouchstart = function(e) {
            var markerType =  $('#markerType').val();
//          console.log(markerType)
//          console.log(type)
            if (type == 'input' || type== 'del' || markerType!=-1 || !vm.taskDetailDoodlesBoxShow) return;
            var isOnmouseMove = 1; //用于判断点击canvas是否进行移动 如果等于2 移动了 就往xyList里添加数据
            var bw = img.width * tz / img.width;
            let pt = convertPoint(e);
            x = e.touches[0].pageX - getCanvasScrollX();
            if(!vm.lockOrientationType){
            	y = e.touches[0].pageY - topBarHeight - getCanvasScrollY();
            }else{
            	y = e.touches[0].pageY - getCanvasScrollY();
            }
            if (type == "pen") {
//          	console.log(JSON.stringify(pt))
//          	console.log(tz)
                obj.beginPath();
                obj.moveTo(pt.x, pt.y);
                penList.push(pt);
                penAllList.push({'x':pt.x / tz,'y': pt.y / tz});
            }
            //实例化构造函数
            var draw = new Draw(obj, {
                type: style,
                color: color,
                width: linewidth
            });
            //鼠标移动
            canvas.ontouchmove = function(e) {
                var markerType =  $('#markerType').val();
                if (type == 'input' || type== 'del' || markerType!=-1 || !vm.taskDetailDoodlesBoxShow) return;
                isOnmouseMove = 2;
                
                //移动时保持滚动条位置
                mui('.mui-scroll-wrapper-main').scroll().scrollTo(vm.objScrollLeft,vm.objScrollTop,0)
                
                w = e.touches[0].pageX - getCanvasScrollX();
                if(!vm.lockOrientationType){
                	h = e.touches[0].pageY - topBarHeight - getCanvasScrollY();
                }else{
                	h = e.touches[0].pageY - getCanvasScrollY();
                }
                
                if (type != "pen") {
                    obj.clearRect(0, 0, width, height);
                    if (arr.length != 0) {
                        obj.putImageData(arr[arr.length - 1], 0, 0, 0, 0, width, height);
                    }
                }

                if (type == 'pen') {
                    let pt = convertPoint(e);
                    draw[type](pt,1);
                }else{
                    draw[type](x, y, w, h);
                }

            }
            //鼠标抬起
            canvas.ontouchend = function() {
            	canvas.ontouchmove = null;
                canvas.ontouchend = null;
                var markerType =  $('#markerType').val();
                if (type == 'input' || type== 'del' || markerType!=-1 || !vm.taskDetailDoodlesBoxShow || isOnmouseMove != 2){
                	isOnmouseMove = 1;
                    return;
                }
                arr.push(obj.getImageData(0, 0, width, height));
                if (type == 'pen') {
                    obj.closePath();
                    xyList.push({
                        'type': type,
                        'w': x / bw,
                        'h': y / bw,
                        'cw': width,
                        'ch': height,
                        'color': color,
                        'linewidth': linewidth,
                        'xy': penAllList
                    });
                    xyListTwo.push({
                        'type': type,
                        'w': x / bw,
                        'h': y / bw,
                        'cw': width,
                        'ch': height,
                        'color': color,
                        'linewidth': linewidth,
                        'xy': penAllList
                    });
                    penAllList = [];
                    penList = [];
                } else {
                    xyList.push({
                        'type': type,
                        'x': x / bw,
                        'y': y / bw,
                        'w': w / bw,
                        'h': h / bw,
                        'cw': width,
                        'ch': height,
                        'color': color,
                        'linewidth': linewidth
                    });
                    xyListTwo.push({
                        'type': type,
                        'x': x / bw,
                        'y': y / bw,
                        'w': w / bw,
                        'h': h / bw,
                        'cw': width,
                        'ch': height,
                        'color': color,
                        'linewidth': linewidth
                    });
                }
            }
        }

        //鼠标点击
        canvas.addEventListener('tap', function(e) {
        	var eOffX = e.detail.gesture.changedTouches[0].pageX - getCanvasScrollX(); 
        	if(!vm.lockOrientationType){
            	eOffY = e.detail.gesture.changedTouches[0].pageY - topBarHeight - getCanvasScrollY();
            }else{
            	eOffY = e.detail.gesture.changedTouches[0].pageY - getCanvasScrollY();
            }
//          console.log(eOffY);
        	var markerType =  $('#markerType').val();
			if (markerType!=-1 || !vm.taskDetailDoodlesBoxShow) return;
			
            if (type == 'input') {
//              removeTestStr();
                var btnArray = ['取消', '确定'];
                mui.prompt('添加文字涂鸦', '请输入内容',"提示", btnArray, function(e) {
                    if (e.index == 1) {
		                var x = (eOffX) / tz;
		                var y = (eOffY) / tz;
		                var textareaStr = '<textarea onblur="saveTextarea()" data-x="' + x + '" data-y="' + y + '" class="text-str" style="left:' + (eOffX-scrollLeft) + 'px;top:' + (eOffY)+'px;position: absolute;background: transparent;min-width:100px;padding:0;min-height:25px;color:' + color + '">'+e.value+'</textarea>';
		                
		//              var textareaStr = '<textarea rows="1" cols="20" onblur="saveTextarea(this)" data-x="' + x + '" data-y="' + y + '" class="text-str" style="left:' + (e.offsetX+30-scrollLeft) + 'px;top:' + (e.offsetY-10)+'px;position: absolute;background: transparent;color:' + color + '"></textarea>';
		                
		                $('#div-text').append(textareaStr);
		                saveTextarea();
//		                $("textarea").focus();
//						$("textarea").blur();
		                
//                      info.innerText = '谢谢你的评语：' + e.value;
                    } else {
//                      info.innerText = '你点了取消按钮';
                    }
                })
            }else if(type =='del'){
                clickLineIsList(eOffX,eOffY);
            }
        }, false);
    }
};


function inTo() {
    saveTextarea();
}

//画图
function drawing(isBw) {
	clearCanvas();
    if(!vm.showMarkerFlag){return};
    
    /*canvasValueEcho(false);*/
    var bw = tz;
//  console.log(isBw)
    for (var i = 0; i < xyListTwo.length; i++) {
        var temp = xyListTwo[i];
        if (temp.type != 'pen' && temp.type !='input') {
            var draw = new Draw(obj, {
                type: 'stroke',
                color: temp.color,
                width: temp.linewidth
            });
            if(isBw){
                draw[temp.type](temp.x * bw, temp.y * bw, temp.w * bw, temp.h * bw);
            }else{
                draw[temp.type](temp.x, temp.y, temp.w, temp.h);
            }

        } else if(temp.type=='pen') {
            drawPenList(temp, bw);
        } else if(temp.type =='input'){
            obj.font = '16px Arial';
            obj.fillStyle = temp.color;
//          console.log(isBw)
            if(isBw){
                drawText(temp.val,temp.color,temp.x * bw,temp.y * bw,120);
                /*obj.fillText(temp.val,temp.x * bw ,temp.y * bw);*/
            }else{
                drawText(temp.val,temp.color,temp.x,temp.y,120);
                /*obj.fillText(temp.val,temp.x,temp.y);*/
            }
        }
        arr.push(obj.getImageData(0, 0, width, height));
    }
    if (arr.length != 0) {
        obj.putImageData(arr[arr.length - 1], 0, 0, 0, 0, width, height);
    }
};


function drawPenList(zoom,bw){
    obj.beginPath();
    penList = [];
    var draw = new Draw(obj, {
        type: 'stroke',
        color: zoom.color,
        width: zoom.linewidth
    }); //实例化构造函数
    for(var z=0;z<zoom.xy.length;z++){
        var pz = zoom.xy[z];
        if(z==0){
            penList.push(pz);
            obj.moveTo(pz.x * bw, pz.y * bw);
        }else{
            draw['penTwo'](pz,bw);
        }
    }
    obj.closePath();
}

//如果input为空 则删除
function removeTestStr() {
    $('.text-str').each(function() {
        if ($(this).val() == '') {
            $(this).remove();
        }
        $(this).css('border', '0px');
        $(this).css('resize', 'none');
    });
};


var textAreaList = []; //用来存储文本域坐标和值
//保存图上文本域的坐标值
function saveTextarea(_this) {
	var $this = $("textarea");
	
	mui('.mui-scroll-wrapper-main').scroll().scrollTo(vm.objScrollLeft,vm.objScrollTop,0);
	
    var x = $this.data('x')+3;
    var y = $this.data('y')+10;
    var w = $this.css('width') ? $this.css('width') : 0;
    var h = $this.css('height') ? $this.css('height') : 0;
    w = w.replace("px","");
    h = h.replace("px","");
    var color = $this.css('color');
    var val = $this.val();
    if(val==undefined || val==''){
        $this.remove();
        return;
    }
    var bw = img.width * tz / img.width;
    xyList.push({
        type: 'input',
        x: x,
        y: y,
        w: w,
        h: h,
        cw: width,
        ch: height,
        color: color,
        linewidth: 0,
        val: val
    });
    xyListTwo.push({
        type: 'input',
        x: x,
        y: y,
        w: w,
        h: h,
        cw: width,
        ch: height,
        color: color,
        linewidth: 0,
        val: val
    });
    drawText(val,color,x * bw,y * bw,w);
    /* obj.font = '16px Arial';
     obj.fillText(val,x * bw,y * bw);*/
    arr.push(obj.getImageData(0, 0, width, height));
    obj.putImageData(arr[arr.length - 1], 0, 0, 0, 0, width, height);
    $this.remove();
};





function bigOrSmallDraw(tz) {
    initCanvas('huabu', document.getElementById("questionImage").src, false);
    var bw = tz;
    for (var i = 0; i < xyList.length; i++) {
        var xyTwo = xyListTwo[i];
        var xy = xyList[i];
        if(xy.type!='pen') {
            xyTwo.x = (xy.x * bw);
            xyTwo.y = (xy.y * bw);
            xyTwo.w = (xy.w * bw);
            xyTwo.h = (xy.h * bw);
        }
    }
    
    drawing();
}


function clickLineIsList(x,y){
    var r = lineHasList(x,y);
    if(r == -1){
        return;
    }
    xyList.splice(r,1);
    xyListTwo.splice(r,1);
    clearCanvas();
    bigOrSmallDraw(tz);
}

var scrollLeft = 0;
//$(function(){
//  $('.readingPaperBox').scroll(function(){
//      scrollLeft = this.scrollLeft;
//  });
//})