/**
 * 操作：田文汉
 * 时间：2018-7-23
 * @param {Object} cc 自定义组件
 * @param {Object} doc dom选择
 * @param {Object} mui  mui选择
 */

/**
 *  注意（非常重要）， interface.js 一定要在 common.js 之前引入 
 */
var $cc = new Object;
var $getAjax = new Object;
(function(cc,dom,mui){
	  $cc = {
	  	/**
	  	 * 弹窗
	  	 * @param {Object} str
	  	 */
	  	_c:function(str){
	  		console.log(JSON.stringify(str));
	  	},
	  	/**
	  	 * 隐藏提示
	  	 * @param {Object} str
	  	 */
	  	_o:function(str){
	  		mui.toast(str);
	  	},
	  	/**
	  	 * 单选择器
	  	 * @param {Object} str
	  	 */
		query:function(str){
			var oElm = dom.querySelector(str);  
			return oElm ;
		},
		/**
		 * 多选择器
		 * @param {Object} str
		 */
		queryAll:function(str){
			var oElmAll = dom.querySelectorAll(str);
			return oElmAll; 
		},
		//处理填空题input框。
		showLineNum:function(){
//			Object.prototype.replaceWith = function(newElem){
//			 this.outerHTML = arguments[0]; 
//			 return this; 
//			}
////			input转下划线
//			var inputs = document.querySelectorAll('.fillin-blank');
//			for(var i = 0;i < inputs.length;i++){
//				var index = inputs[i].getAttribute("data-index");
//				var length = inputs[i].getAttribute("data-length")?inputs[i].getAttribute("data-length"):10;
//				var con = "";
//				for(var k=0;k<length/2;k++){
//					con+='&nbsp;'
//				}
//				var conAll = document.createElement("u");
//				conAll.innerHTML = con+(Number(index)+1)+con;
//				inputs[i].replaceWith(conAll);
//			}
			jQuery(".fillin-blank").each(function(num,e){
				var index = $(e).data("index");
				var length = $(e).data("length")?$(e).data("length"):10;
				var con = "";
				for(var i=0;i<length/2;i++){
					con+='&nbsp;'
				}
				$(e).replaceWith('<u>'+con+(Number(index)+1)+con+'</u>')
			})
			//img加前缀
			var img = document.querySelectorAll('img');
			for(var i = 0;i < img.length;i++){
				var imgSrc = img[i].getAttribute("src");
				imgSrc = IMG_ROOT_URL+imgSrc;
				img[i].setAttribute("src",imgSrc);
				if(img[i].className!='myAnswer'){
					img[i].style.width = img[i].getAttribute("width");
					img[i].style.height = img[i].getAttribute("height");
				}
			}
			//mathAjx格式
			MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
		},
		/**
		 * 添加类
		 * @param {Object} elements
		 * @param {Object} cName
		 */
		addClass : function ( elements,cName ){
			if( !hasClass( elements,cName ) ){
				elements.className += " " + cName; 
			}; 
		},
		/**
		 * 删除类
		 * @param {Object} elements
		 * @param {Object} cName
		 */
		removeClass : function ( elements,cName ){
			if( hasClass( elements,cName ) ){ 
				elements.className = elements.className.replace( new RegExp( "(\\s|^)" + cName + "(\\s|$)" )," " ); 
			}; 
		},
		/**
		 * 字符串去重
		 * @param {Object} str 需要去重的字符串，需用逗号隔开
		 */
		filterRepeatStr : function (str){
			var ar2 = str.split(";");
			var array = new Array();
			var j=0
			for(var i=0;i<ar2.length;i++){ 
				if((array == "" || array.toString().match(new RegExp(ar2[i],"g")) == null)&&ar2[i]!=""){ 
				array[j] =ar2[i]; 
				array.sort();
				j++;
				}
			}
			return array.toString();
		},
		/**
		 * 截取时间的日期部分
		 */
		interceptionDate:function(time){
			return time.slice(0,10);
		},
		/**
		 * 设置自定义事件
		 * @param {Object} page
		 * @param {Object} name
		 * @param {Object} data
		 */
		setEvent:function(page,name,data){
			var oTargetPage = "" ;
			//判断一下 page 是一个窗口对象，还是一个 窗口地址字符串
			if(Object.prototype.toString.call(page) === "[object String]"){
				oTargetPage  =	plus.webview.getWebviewById(page);
				mui.fire(oTargetPage,name,data);
			}else{
				mui.fire(page,name,data);
			}

		},
		/**
		 * 获取自定义事件
		 * @param {Object} name
		 * @param {Object} fn
		 */
		getEvent:function(name,fn){
			window.addEventListener(name,fn);
		},
		/**
		 * css 选择器 改变样式
		 * @param {Object} str
		 * @param {Object} json
		 */
		css:function(str,json,fn){
			var oElm = dom.querySelectorAll(str);
			mui.each(oElm,function(index,elm){
				for(var num in json){
					elm.style[num] = json[num];
				}
			})
			//回调函数
			if(fn){
				fn();
			}
		},
		/**
		 * 打开 一个预加载窗口 ，如果不传参，默认打开父窗口
		 * 当前方法只是针对预加载页面，或者，已经打开的页面 ， 其目的是显示动画
		 * @param {Object} target  目标窗口对象，或是 窗口id
		 */
		show:function(target){
			var current = plus.webview.currentWebview(),currentId;
			//判断目标窗口是否存在 
			console.log(target);
			if(target){
				// 判断target 是一个窗口对象，还是一个字符串
				if(Object.prototype.toString.call(target) === "[object String]"){
					currentId = plus.webview.getWebviewById(target);
				}else {
					currentId = target ;
				}
				currentId.hide();// 如果存在，那么将其隐藏
				currentId.show("pop-in");
			}else{
				current.opener().hide(); //如果目标窗口不存在 ，那么当前窗口的父窗口隐藏
				current.opener().show("pop-in");
			}
			
		}
		
	};
	
	
	
	/**
	 * 查找类
	 * @param {Object} elements
	 * @param {Object} cName
	 */
	function hasClass( elements,cName ){
		return !!elements.className.match( new RegExp( "(\\s|^)" + cName + "(\\s|$)") ); 
	}
	/**
	 * ajax 获取数据
	 * @param {Object} str
	 */
	$getAjax =function(url,data,contentJson){ 
		data.data = data.data?data.data:{}; 
//		if(localStorage.getItem("$state")){
//			data.data.clientauthtoken = JSON.parse(localStorage.getItem("$state")).data;
//		}
		// 接口访问失败，默认执行函数
		var error =function(xhr,type,errorThrown){
			if(type == "timeout"){
				plus.nativeUI.toast("访问超时，请稍后重试或联系管理员");
				return false;
			}else{
				if(xhr.responseText){
					if(xhr.responseText.indexOf("登录") != -1){
						plus.nativeUI.toast("访问超时,请重新登录");
					}else{
						plus.nativeUI.toast("访问异常请联系管理员或尝试重新登录");
					}
				}else{
					plus.nativeUI.toast("访问异常请联系管理员或尝试重新登录");
				}
			}
//			console.log(xhr.responseText)
//			console.log(xhr.responseText.indexOf("登录"))
				//异常处理；
        		var loginFlag = plus.storage.getItem("loginFlag");
				if(!loginFlag || loginFlag == "false"){
					plus.nativeUI.toast("请重新登录");
					plus.storage.setItem("loginFlag","true");
					mui.openWindow({
	                    "url": '../../html/login/login.html',
	                    id: 'html/login/login.html',
	                    show: {
	                        aniShow: 'pop-in'
	                    }
	                })
				}
				console.log("error:"+xhr.responseText);
			}
		//接口访问成功，默认执行函数
		var success = function(data){ 
				console.log("访问接口成功，data："+ JSON.stringify(data));
			}
		var strN = "" ; 
		for(var a in data.data){
			strN += a+"="+data.data[a]+"&" ;
		}
		var oldUrl = localStorage.getItem("urlInput");
		if(oldUrl){
			ROOT_URL = oldUrl + "/";
			IMG_ROOT_URL = oldUrl.split("/").slice(0,3).join("/");
		}
		console.log("----提交地址----"+ROOT_URL+url+"?"+strN) ;  
		mui.ajax(ROOT_URL+url,{
			contentType:"application/x-www-form-urlencoded;charset=utf-8",
			data:data.data,
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			contentType:contentJson?"application/json":"application/x-www-form-urlencoded",
//			timeout:15000,//超时时间设置为15秒；
			success:function(res){
				data.success?data.success(res):success(res);
//				if(!data.closeWaiting){
					plus.nativeUI.closeWaiting();
//				}
			},
			error:function(xhr,type,errorThrown){
				data.error?data.error(xhr,type,errorThrown):error(xhr,type,errorThrown);
				plus.nativeUI.closeWaiting();
			}
		});//ajax end
	}
		
})(window,document,mui)



