(function($, doc) {
	$.init();
	$.plusReady(function() {
		/**
         * 获取本地存储中launchFlag的值
         * http://www.html5plus.org/doc/zh_cn/storage.html#plus.storage.getItem
         * 若存在，说明不是首次启动，直接进入首页；
         * 若不存在，说明是首次启动，进入引导页；
         */
        var launchFlag = plus.storage.getItem("launchFlag");
        console.log(launchFlag)
        if(!launchFlag) {
        	mui.openWindow({
        	    url: "guide.html",
        	    id: "guide"
        	});
        } else {
    		// close splash
			setTimeout(function() {
				//关闭 splash
				plus.navigator.closeSplashscreen();
			}, 600);
			
			//判断是否有登录信息
    		tryLogin();
        }

		
		
		
		
		
		
		//1、判断是否有登录信息
    	function tryLogin(){
    		if(Object.keys(app.getState()).length==0){
				$.openWindow({
                    "url": 'html/login/login.html',
                    id: 'html/login/login.html',
                    show: {
                        aniShow: 'pop-in'
                    }
                })
			}else{
				upUserData();
			}
    	}
		
		//2、如果去登录，登录完成监听页面数据更新
		$cc.getEvent("getData",function(){
			if(mui('.mui-off-canvas-wrap').offCanvas().isShown()){
            	mui('.mui-off-canvas-wrap').offCanvas('close');
            }
			var id = setInterval(function () {
				if(app.getState()){
					upUserData();
					clearInterval(id);
				}
			},20);
			var login = plus.webview.getWebviewById("html/login/login.html");
			plus.webview.close(login)
		})
		//改密码,头像后监听
		$cc.getEvent("tryLogin",function(){
        	app.setState({});
			tryLogin();
		})
		//页面数据更新
		function upUserData(){
			plus.nativeUI.showWaiting("加载中...", {
				width: "120px"
			});
			$getAjax(SERVICE.getResUser,{ 
				data:{
					userId:0
				},
				success:function(data){
					if(data.result == 0){
						localStorage.setItem("userData",JSON.stringify(data.data));
						var resData = data.data;
						console.log(JSON.stringify(data.data))
						$cc.query(".userName").innerHTML = resData.resUser.displayName || "";
						var gradeSubjectName = resData.gradeName || "";
						gradeSubjectName += " "+ (resData.subjectName || "");
						$cc.query(".userGrade").innerHTML = gradeSubjectName;
						$cc.query(".userName2").innerHTML = resData.resUser.displayName || "";
						$cc.query(".userGrade2").innerHTML = gradeSubjectName;
						
						if(resData.resUser.userImage!=null&&resData.resUser.userImage!=""){
							$cc.query("#head_portrait").src = IMG_ROOT_URL+resData.resUser.userImage;
							$cc.query("#userImg").src = IMG_ROOT_URL+resData.resUser.userImage;
						}else{
							$cc.query("#userImg").src = 'images/userImg.jpg';
							$cc.query("#head_portrait").src = 'images/userImg.jpg';
						}
						
						//获取公告
						getNotices();
						//获取阅卷信息
						getReadPaper();
					}else{
						$.openWindow({
		                    "url": 'html/login/login.html',
		                    id: 'html/login/login.html',
		                    show: {
		                        aniShow: 'pop-in'
		                    }
		                })
					}
				}
			})
		}
		
		//获取公告列表
		function getNotices(){
			$getAjax(SERVICE.getNoticesJson,{
				data:{
					index:1,
					size:3
				},
				success:function(data){
					if(data.result == 0){
						vm.noticesList = data.data;
					}else{
//						plus.nativeUI.toast(data.msg);
					}
				}
			})
		}
		//获取阅卷列表
		function getReadPaper(){
			$getAjax(SERVICE.listTeacherTask,{
				data:{
					page:1,
					rows:6,
					name:"",
					status:""
				},
				success:function(data){
					if(data.result == 0){
						vm.readPaperList = data.data;
					}else{
//						plus.nativeUI.toast(data.msg);
					}
				}
			})
		}
		var vm = new Vue({
	        el: '#vueApp',
	        data: {
	            noticesList: [],
	            readPaperList:[]
	        },
			methods: {
				toNoticeDetail:function(noticeId) {
					mui.openWindow({
						id: 'html/notice/noticeDetail.html',
						url:'html/notice/noticeDetail.html',
						show: {
							aniShow: 'pop-in'
						},
						styles: {
							popGesture: 'hide'
						},
						waiting: {
							autoShow: false
						},
						extras: {
	                        noticeId: noticeId
	                    }
					});
				},
				toNoticeList:function(){
					$.openWindow({
						url: 'html/notice/noticeList.html',
						id: 'html/notice/noticeList.html',
						show: {
							aniShow: 'pop-in'
						}
					})
					toToggleNvuew(1);
					
				},
				toReadPaperList:function(){
//					plus.webview.open('html/readPaper/readPaperList.html', 'new', {}, 'slide-in-right', 200);
					mui.openWindow({
						id: 'html/readPaper/readPaperList.html',
						url:'html/readPaper/readPaperList.html',
						show: {
							aniShow: 'pop-in'
						}
					});
					toToggleNvuew(2);
				},
				toDetail:function(data) {
					mui.openWindow({
						id: 'html/readPaper/taskDetail.html',
						url:'html/readPaper/taskDetail.html',
						show: {
							aniShow: 'pop-in'
						},
						styles: {
							popGesture: 'hide'
						},
						waiting: {
							autoShow: false
						},
						extras: {
	                        taskData:data
	                    }
					});
				}
			}
	    })
		
		//弹出左边栏
        var userBtn = doc.getElementById("userBtn");
        userBtn.addEventListener('tap', function (event) {
            mui(".mui-off-canvas-wrap").offCanvas("toggle");
        })
        
        
        var changePasswordBtn = doc.getElementById("changePasswordBtn");
        changePasswordBtn.addEventListener('tap', function (event) {
            $.openWindow({
                "url": 'html/login/change_password.html',
                id: 'html/login/change_password.html',
                show: {
                    aniShow: 'pop-in'
                }
            })
        })
        
        var exit = doc.getElementById("exit");
        exit.addEventListener('tap', function (event) {
        	app.setState({});
        	plus.navigator.removeAllCookie();
			mui.openWindow({
				url: 'html/login/login.html',
				id: 'html/login/login.html',
				show: {
					aniShow: 'pop-in'
				}
			});
        })
		
		
		mui("body").on("tap",".mui-inner-wrap",function(){
        	if (mui('.mui-off-canvas-wrap').offCanvas().isShown()) {
                mui('.mui-off-canvas-wrap').offCanvas('close');
                return;
            }
        })
		
		
		
		
		
		
		
		
		
		
		
		
		
//		
//		//画图标
//		var self = plus.webview.currentWebview(),
//			leftPos = Math.ceil((window.innerWidth - 60) / 2); // 设置凸起大图标为水平居中
//
//		/**	
//		 * drawNativeIcon 绘制带边框的半圆，
//		 * 实现原理：
//		 *   id为bg的tag 创建带边框的圆
//		 *   id为bg2的tag 创建白色矩形遮住圆下半部分，只显示凸起带边框部分
//		 * 	 id为iconBg的红色背景图
//		 *   id为icon的字体图标
//		 *   注意创建先后顺序，创建越晚的层级越高
//		 */
//		var drawNativeIcon = util.drawNative('icon', {
//			bottom: '5px',
//			left: leftPos + 'px',
//			width: '60px',
//			height: '60px'
//		}, [{
//			tag: 'rect',
//			id: 'bg',
//			position: {
//				top: '1px',
//				left: '0px',
//				width: '100%',
//				height: '100%'
//			},
//			rectStyles: {
//				color: '#fff',
//				radius: '50%',
//				borderColor: '#ccc',
//				borderWidth: '1px'
//			}
//		}, {
//			tag: 'rect',
//			id: 'bg2',
//			position: {
//				bottom: '-0.5px',
//				left: '0px',
//				width: '100%',
//				height: '45px'
//			},
//			rectStyles: {
//				color: '#fff'
//			}
//		}, {
//			tag: 'rect',
//			id: 'iconBg',
//			position: {
//				top: '5px',
//				left: '5px',
//				width: '50px',
//				height: '50px'
//			},
//			rectStyles: {
//				color: '#aaa',
//				radius: '50%'
//			}
//		}, {
//			tag: 'font',
//			id: 'icon',
//			text: '\ue301', //此为字体图标Unicode码'\e600'转换为'\ue600'
//			position: {
//				top: '0px',
//				left: '5px',
//				width: '50px',
//				height: '100%'
//			},
//			textStyles: {
//				fontSrc: '_www/fonts/mui.ttf',
//				align: 'center',
//				color: '#fff',
//				size: '30px'
//			}
//		}]);
//		// append 到父webview中
//		self.append(drawNativeIcon);
//
//		//自定义监听图标点击事件
//		var active_color = '#fff';
//		drawNativeIcon.addEventListener('click', function(e) {
////			$.alert('你点击了图标，你在此可以打开摄像头或者新窗口等自定义点击事件。', '悬浮球点击事件');
//			// 重绘字体颜色
//			if(active_color == '#fff') {
//				drawNativeIcon.drawText('\ue301', {}, {
//					fontSrc: '_www/fonts/mui.ttf',
//					align: 'center',
//					color: '#000',
//					size: '30px'
//				}, 'icon');
//				active_color = '#000';
//			} else {
//				drawNativeIcon.drawText('\ue301', {}, {
//					fontSrc: '_www/fonts/mui.ttf',
//					align: 'center',
//					color: '#fff',
//					size: '30px'
//				}, 'icon');
//				active_color = '#fff';
//			}
//
//		});
//		// 中间凸起图标绘制及监听点击完毕
//
		// 创建子webview窗口 并初始化
		var aniShow = {};
		util.initSubpage(aniShow);
		
		var nview = plus.nativeObj.View.getViewById('tabBar'),
			activePage = plus.webview.currentWebview(),
			targetPage,
			subpages = util.options.subpages,
			pageW = window.innerWidth,
			currIndex = 0;
		
		/**
		 * 根据判断view控件点击位置判断切换的tab
		 */
		nview.addEventListener('click', function(e) {
			var clientX = e.clientX;
			if(clientX > 0 && clientX <= parseInt(pageW * 0.25)) {
				currIndex = 0;
			} else if(clientX > parseInt(pageW * 0.25) && clientX <= parseInt(pageW * 0.45)) {
				currIndex = 1;
			} else if(clientX > parseInt(pageW * 0.45) && clientX <= parseInt(pageW * 0.8)) {
				currIndex = 2;
			} else {
				currIndex = 3;
			}
			toToggleNvuew(currIndex)
		});
		
		//导航条跳转
		function toToggleNvuew(currIndex){
			// 匹配对应tab窗口	
			if(currIndex > 0) {
				targetPage = plus.webview.getWebviewById(subpages[currIndex - 1]);
			} else {
				targetPage = plus.webview.currentWebview();
			}

			if(targetPage == activePage) {
				return;
			}

			//底部选项卡切换
			util.toggleNview(currIndex);
			// 子页面切换
			util.changeSubpage(targetPage, activePage, aniShow);
			//更新当前活跃的页面
			activePage = targetPage;
		}








		/*************改头像******************************/
       var editHeadData = "",  //修改后的头像
		   head_portrait = $cc.query("#head_portrait"),
		   userImg = $cc.query("#userImg");
       
        window.addEventListener("headPic",function(event){
			editHeadData = event.detail.headData;
			head_portrait.src=event.detail.headData;
			userImg.src=event.detail.headData;
			console.log(event.detail.headData); 
		}); 
        //更换头像
//		head_portrait.addEventListener("tap", function() {
//			if(mui.os.plus) {
//				var a = [{
//					title: "拍照"
//				}, {
//					title: "从手机相册选择"
//				}];
//				plus.nativeUI.actionSheet({
//					cancel: "取消",
//					buttons: a
//				}, function(b) { //actionSheet按钮点击事件
//					switch(b.index) {
//						case 0:
//							break;
//						case 1:
//							getImage(); //拍照
//							break;
//						case 2:
//							galleryImg(); //打开相册
//							break;
//						default:
//							break
//					}
//				})
//			}
//		});
		
		//	更换头像
		var images = [];
		function getImage() {
			var cmr = plus.camera.getCamera();
			cmr.captureImage(function(p) {
				plus.io.resolveLocalFileSystemURL(p, function(entry) {
					mui.openWindow({
						url: 'cropper/cropper.html',
						id: 'cropper/cropper.html',
						extras: {
							path: "file:///" + entry.fullPath, 
							change: "cem"
						}
					});
				}, function(e) {
					mui.toast(e.message);
				});
			}, function(e) {}, {
				filename: "_doc/camera/"
			});
		}
	
		function galleryImg() {
			
			plus.gallery.pick(function(url) {
				mui.openWindow({
					url: 'cropper/cropper.html',
					id: 'cropper/cropper.html',
					extras: {
						path: url,
						change: "open"
					}
				});
			}, function(error) {
				mui.toast("打开相册失败"); 
			});
		};
        /*************改头像end******************************/
	});
})(mui, document);